#!/usr/bin/python

domains_path = "./domains/"
domain_words_extension = "_words.txt"

import os
from random import choice

def get_available_target_domains():
	os.chdir(domains_path)

	domains = []
	#list target domains available
	for files in os.listdir("."):
	    if files.endswith(domain_words_extension):
	        domains.append(files)
	return domains

def get_vocabulary_from_domain(domain):
	words = []
	selected_domain = open (domain,"r")
	words = selected_domain.readlines()
	return words

def generate_string(threshold,words,expected_length):
	generative_string = []
	fitness = 0
	while fitness < threshold:
		for count in range(1,expected_length):
			picked_word = choice(words)
		# removing trailing \n
		generative_string.append(picked_word[0:len(picked_word)-1])

		fitness = evaluate_fitness(generative_string)
	return [generative_string,fitness]

def evaluate_fitness(generative_string):
	return choice(range(1,10))

def user_defined_fitness(specification,domain):
	return false

def render(generative_string,domain):
	#get result with mime-type
	#get output for debug
	#via warped exec
	return false

def mutation(generative_string,domain,number_of_mutations):
	#should still keep track of history, thus be or become part of a phylogeny
	return new_generative_string

def mix(gs1,gs2,number_of_crossovers):
	#should still keep track of history, thus be or become part of a phylogeny
	return new_generative_string

def revere_repository(path,domain):
	#should generate a phylogeny
	return false

